'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref2) {
    var serverURL = _ref2.serverURL,
        appId = _ref2.appId,
        masterKey = _ref2.masterKey;
    var response;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _axios2.default)({
              method: 'get',
              url: serverURL + '/schemas',
              headers: {
                'X-Parse-Application-Id': appId,
                'X-Parse-Master-Key': masterKey
              }
            });

          case 2:
            response = _context.sent;

            if (!(response.status !== 200)) {
              _context.next = 5;
              break;
            }

            throw new Error('Error retrieving Parse schema');

          case 5:
            if (!(!(0, _lodash.get)(response, 'data.results') || !response.data.results.length)) {
              _context.next = 7;
              break;
            }

            throw new Error('No Parse classes found');

          case 7:
            return _context.abrupt('return', response.data.results);

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function fetchParseSchema(_x) {
    return _ref.apply(this, arguments);
  }

  return fetchParseSchema;
}();

module.exports = exports['default'];