'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

exports.default = parseGraphQL;

var _expressGraphql = require('express-graphql');

var _expressGraphql2 = _interopRequireDefault(_expressGraphql);

var _generateSchema = require('./generateSchema');

var _generateSchema2 = _interopRequireDefault(_generateSchema);

var _fetchParseSchema = require('./fetchParseSchema');

var _fetchParseSchema2 = _interopRequireDefault(_fetchParseSchema);

var _node = require('parse/node');

var _node2 = _interopRequireDefault(_node);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

console.log('TEST');

var getSchema = function () {
  var schema = void 0;
  return function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(options, alwaysRecreate) {
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(!schema || alwaysRecreate)) {
                _context.next = 6;
                break;
              }

              _context.t0 = _generateSchema2.default;
              _context.next = 4;
              return (0, _fetchParseSchema2.default)(options);

            case 4:
              _context.t1 = _context.sent;
              schema = (0, _context.t0)(_context.t1);

            case 6:
              console.log(schema);
              return _context.abrupt('return', schema);

            case 8:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }();
}();

function parseGraphQL(options) {
  var _this = this;

  _node2.default.initialize(options.appId);
  _node2.default.serverURL = options.serverURL;
  return (0, _expressGraphql2.default)((0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            _context2.next = 3;
            return getSchema(options, options.dynamicSchema);

          case 3:
            _context2.t0 = _context2.sent;
            _context2.t1 = options.graphiql;
            return _context2.abrupt('return', {
              schema: _context2.t0,
              graphiql: _context2.t1
            });

          case 8:
            _context2.prev = 8;
            _context2.t2 = _context2['catch'](0);

            console.error(_context2.t2);

          case 11:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, _this, [[0, 8]]);
  })));
};
module.exports = exports['default'];