'use strict';

exports.__esModule = true;

var _graphql = require('graphql');

var _graphqlTypeJson = require('graphql-type-json');

var _graphqlTypeJson2 = _interopRequireDefault(_graphqlTypeJson);

var _graphqlListFields = require('graphql-list-fields');

var _graphqlListFields2 = _interopRequireDefault(_graphqlListFields);

var _node = require('parse/node');

var _node2 = _interopRequireDefault(_node);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = function (Type) {
  return {
    type: (0, _graphql.GraphQLList)(Type),
    args: {
      json: {
        type: _graphqlTypeJson2.default
      }
    },
    resolve: function resolve(_, _ref, context, info) {
      var json = _ref.json;

      var _this = this;

      return _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var fields, query;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                fields = (0, _graphqlListFields2.default)(info);
                query = _node2.default.Query.from(json);

                fields.forEach(function (field) {
                  return query.include(field);
                });

              case 3:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this);
      }))();
    }
  };
};

module.exports = exports['default'];