'use strict';

exports.__esModule = true;

var _graphql = require('graphql');

exports.default = new _graphql.GraphQLObjectType({
  name: 'File',
  fields: {
    url: {
      type: _graphql.GraphQLString,
      resolve: function resolve(file) {
        return file.url();
      }
    },
    name: {
      type: _graphql.GraphQLString,
      resolve: function resolve(file) {
        return file.url();
      }
    }
  }
});
module.exports = exports['default'];