'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _fp = require('lodash/fp');

var _graphqlTypeJson = require('graphql-type-json');

var _graphqlTypeJson2 = _interopRequireDefault(_graphqlTypeJson);

var _File = require('./types/File');

var _File2 = _interopRequireDefault(_File);

var _Date = require('./types/Date');

var _Date2 = _interopRequireDefault(_Date);

var _ACL = require('./types/ACL');

var _ACL2 = _interopRequireDefault(_ACL);

var _graphql = require('graphql');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _extends3.default)({}, (0, _fp.mapValues)(_fp.constant, {
  File: _File2.default,
  Date: _Date2.default,
  ACL: _ACL2.default,
  Object: _graphqlTypeJson2.default,
  String: _graphql.GraphQLString,
  Boolean: _graphql.GraphQLBoolean,
  Number: _graphql.GraphQLFloat
}), {
  Pointer: function Pointer(_ref, mapping) {
    var targetClass = _ref.targetClass;
    return mapping[targetClass]();
  }
});
module.exports = exports['default'];