'use strict';

exports.__esModule = true;

var _graphql = require('graphql');

var _fp = require('lodash/fp');

exports.default = new _graphql.GraphQLObjectType({
  name: 'GeoPoint',
  fields: {
    latitude: {
      type: _graphql.GraphQLFloat,
      resolve: (0, _fp.property)('latitude')
    },
    longitude: {
      type: _graphql.GraphQLFloat,
      resolve: (0, _fp.property)('longitude')
    }
  }
});
module.exports = exports['default'];